﻿using Demo.Data.Repository;
using Demo.Domain.UseCase;
using Demo.UI;

class Program
{
    static void Main(string[] args)
    {
        var userRepository = new UserRepositoryImpl();
        var groupRepository = new GroupRepositoryImpl();

        var userUseCase = new UserUseCase(userRepository,groupRepository);
        var groupUseCase = new GroupUseCase(groupRepository);

        var userConsole = new UserConsole(userUseCase);
        var groupConsole = new GroupConsole(groupUseCase);

        var mainMenu = new MainMenu(userConsole, groupConsole);
        mainMenu.ShowMenu();
    }
}
